<?
// http://www.weather.com/services/xmloap.html

function retWeather($loc_id)
{
    $partner_ID = "1011068843";
    $license_key = "81f8f9c210c6588d";
    $xml = "";

    $url = "http://xoap.weather.com/weather/local/$loc_id?cc=*&dayf=5&prod=xoap&par=$partner_ID&key=$license_key";

    // Get XML Query Results
    $fp = fopen($url,"r");
    while (!feof ($fp))
        $xml .= fgets($fp, 4096);
    fclose ($fp);

    $parser = xml_parser_create(  );
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);

    xml_parse_into_struct($parser,$xml,$values,$index);

    xml_parser_free($parser);

    $xml = str_replace("'","",$xml); // handle cities with apostrophies in the name

    //display detailed info
	$city = htmlspecialchars($values[$index["dnam"][0]]["value"]);
 
    if($city == "")
        return FALSE;
        
	$unit_temp = $values[$index["ut"][0]]["value"];
	$unit_speed = $values[$index["us"][0]]["value"];
	$unit_precip = $values[$index["up"][0]]["value"];
	$unit_pressure = $values[$index["ur"][0]]["value"];
	$sunrise = $values[$index["sunr"][0]]["value"];
	$sunset = $values[$index["suns"][0]]["value"];
	$last_update = $values[$index["lsup"][0]]["value"];
	$curr_temp = $values[$index["tmp"][0]]["value"];
	$curr_flik = $values[$index["flik"][0]]["value"];
	$curr_text = $values[$index["t"][0]]["value"];
 
	$counter = 0;
	$row_counter = 2;
 
    //notice hack
    //if($values[$day]["attributes"]["t"] == "") { }

	$tWeatherOut = "<br>Weather report for <b>$city</b> (Last updated $last_update)";
	$tWeatherOut .= "<br>Currently: $curr_temp $unit_temp. Feels Like: $curr_flik $unit_temp.";
    $tWeatherOut .= "<br>Current conditions: $curr_text.";
	$tWeatherOut .= "<br>Sunrise: $sunrise. Sunset: $sunset.";

	foreach ($index["day"] as $day)
	{
		if ($values[$day]["attributes"]["t"] != "")
		{
			$day_text = (($counter + 1) * 3) + $counter + 2;
			$day_wind = ((($counter + 1) * 3) + $counter) + 1;
			$day_windspeed = (($counter + 1) * 2) - 1;
			$day_windgust = (($counter + 1) * 2) - 1;
			$day_humidity = (($counter + 1) * 2) - 1;
			$day_precip = $counter * 2;

			$night_text = ((($counter + 1) * 3) + $counter) + 4;
			$night_wind = ((($counter + 1) * 3) + $counter) + 3;
			$night_windspeed = ($counter + 1) * 2;
			$night_windgust = ($counter + 1) * 2;
			$night_humidity = ($counter + 1) * 2;
			$night_precip = ($counter * 2) + 1;

			$tWeatherOut .= "<br><br><b>" . $values[$day]["attributes"]["t"] . ", " . $values[$day]["attributes"]["dt"] . "</b> (";
			$tWeatherOut .= "Hi: " . $values[$index["hi"][$counter]]["value"] . " $unit_temp, ";
			$tWeatherOut .= "Lo: " . $values[$index["low"][$counter]]["value"] . " $unit_temp)";

            //day
			$tWeatherOut .= "<br><u>Day</u>: <b>" . $values[$index["t"][$day_wind]]["value"] . "</b>";
			$tWeatherOut .= "<br>Wind: " . $values[$index["t"][$day_text]]["value"] . " " . $values[$index["s"][$day_windspeed]]["value"] . " $unit_speed, ";
			$tWeatherOut .= "Humidity: " . $values[$index["hmid"][$day_humidity]]["value"] . "%, ";
            $tWeatherOut .= "Precip: " . $values[$index["ppcp"][$day_precip]]["value"] . "%";

            //night
			$tWeatherOut .= "<br><u>Night</u>: <b>" . $values[$index["t"][$night_wind]]["value"] . "</b>";
			$tWeatherOut .= "<br>Wind: " . $values[$index["t"][$night_text]]["value"] . " " . $values[$index["s"][$night_windspeed]]["value"] . " $unit_speed, ";
			$tWeatherOut .= "Humidity: " . $values[$index["hmid"][$night_humidity]]["value"] . "%, ";
            $tWeatherOut .= "Precip: " . $values[$index["ppcp"][$night_precip]]["value"] . "%";
            
			$counter++;
			$row_counter++;
		}
	}
 
    return $tWeatherOut;

}

?>
