<?
	/************************************************************************
	Myth2 v2.1
	Copyright (c) 2003, solidox
	All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:
	1. Redistributions of source code must retain the above copyright
		notice, this list of conditions and the following disclaimer.
	2. Redistributions in binary form must reproduce the above copyright
		notice, this list of conditions and the following disclaimer in the
		documentation and/or other materials provided with the distribution.
	3. The name of the author may not be used to endorse or promote
		products derived from this software without specific prior
		written permission.
	
	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
	OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
	DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
	GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
	OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	************************************************************************/
	
	/* Basic Config */
	define('ADMIN_USER', 'admin'); //admin username
	define('ADMIN_PASS', 'default'); //admin password. if you wish to use md5, put an md5 string in here and set the MYTH_MD5PASS var.
	define('MYTH_TITLE', 'Myth2'); //this is what appears in the <title> tag.
	define('MYTH_CSS', 'default.css'); //sets the stylesheet to use.
	define('MYTH_SHOWCOUNT', 1); //shows the node count next to the tree selection.
	define('MYTH_SHOWIP', 0); //show the ip of node author when logged in as admin
	define('MYTH_USESTATS', 0); // enable or disable the logging of basic stats/referers.
	define('MYTH_SHOWLOGIN', 1); // show login link on main page, set to 0 for a wee bit of additional security.
								 // with this enabled you would access http://url/myth2.php?w=login to login.
	// New in 2.1
	define('MYTH_ANON', 'anonymous'); // name to give anonymous users
	define('MYTH_ALLOWRATING', 0); //allows or disallows rating of nodes
	define('MYTH_ALLOWLIST', 1); //enables link to show whole branch of a node
	define('MYTH_LISTMODE', 3); //default mode for listing format
	define('MYTH_PUBLICLATEST', 0); //can non-admins see the latest links?
	define('MYTH_DEFLIMIT', 20); //sets the default number per page of latest nodes
	define('MYTH_USEFILTER', 1); //enable the filter (search/replace)
	
	/* Advanced Config */
	define('USE_GZIP', 0); //enable gzip compression
	define('MYTH_MD5PASS', 0); //set this to 1 if your ADMIN_PASS is md5'ed.
	define('MYTH_NOCOOKIES', 0); //set to 1 this will disable the saving of cookies to remember a users name
	define('MYTH_EMBEDDED', 0); // set this to 1 if you are using it inside another website via an include() for example
								// this suppresses the html header/footer (<html>,<head>,<body>, etc)
	/* End Config */
	
	define('MYTH_VERSION', '2.1');
	if(ADMIN_PASS == 'default')
		die("Please edit myth2.php and change the default admin user/pass");
	function getmicrotime(){ 
	   list($usec, $sec) = explode(" ",microtime()); 
	   return ((float)$usec + (float)$sec); 
	   } 
	$time_start = getmicrotime();

	class iMyth
	{
		function Init()
		{
			require("dbmyth.php");
			@mysql_pconnect($DB_SERVER, $DB_USERNAME, $DB_PASSWORD)
				or die("Could not connect to the MySQL Server, admin has been notified.");
			@mysql_select_db($DB_DATABASE)
				or die("Could not select the database, admin has been notified.");		
		}
		function Install()
		{
			$query = "CREATE TABLE `myth` (
					  `id` int(10) unsigned NOT NULL auto_increment,
					  `title` varchar(255) NOT NULL default '',
					  `description` text NOT NULL,
					  PRIMARY KEY  (`id`)
					) TYPE=MyISAM";
			mysql_query($query)
				or die("Error installing database tables: ".mysql_error());
			$query = "CREATE TABLE `mythfilter` (
					  `id` int(10) unsigned NOT NULL auto_increment,
					  `search` varchar(255) NOT NULL default '',
					  `replace` varchar(255) NOT NULL default '',
					  `regex` int(2) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`)
					) TYPE=MyISAM";
			mysql_query($query)
				or die("Error installing database tables: ".mysql_error());
			$query = "CREATE TABLE `mythnode` (
					  `id` int(10) unsigned NOT NULL auto_increment,
					  `tree` int(10) unsigned NOT NULL default '0',
					  `parent` int(10) unsigned NOT NULL default '0',
					  `author` varchar(32) NOT NULL default '',
					  `authorip` varchar(16) NOT NULL default '',
					  `content` text NOT NULL,
					  `when` timestamp(14) NOT NULL,
					  `option1text` text NOT NULL default '',
					  `option2text` text NOT NULL default '',
					  `option1node` int(10) unsigned NOT NULL default '0',
					  `option2node` int(10) unsigned NOT NULL default '0',
					  `rating` varchar(5) NOT NULL default '',
					  `numratings` int(10) unsigned NOT NULL default '0',
					  PRIMARY KEY  (`id`)
					) TYPE=MyISAM";
			mysql_query($query)
				or die("Error installing database tables: ".mysql_error());
			$query = "CREATE TABLE `mythreferers` (
					  `id` int(10) unsigned NOT NULL auto_increment,
					  `referer` varchar(255) NOT NULL default '',
					  `hits` int(10) unsigned NOT NULL default '1',
					  PRIMARY KEY  (`id`)
					) TYPE=MyISAM";
			mysql_query($query)
				or die("Error installing database tables: ".mysql_error());
			$query = "CREATE TABLE `mythstats` (
					  `id` int(10) unsigned NOT NULL auto_increment,
					  `ip` varchar(16) NOT NULL default '',
					  `when` timestamp(14) NOT NULL,
					  `hits` int(10) unsigned NOT NULL default '1',
					  PRIMARY KEY  (`id`)
					) TYPE=MyISAM";
			mysql_query($query)
				or die("Error installing database tables: ".mysql_error());
			return true;
		}
		function Upgrade($version)
		{
			if($version == '2.0')
			{
				$query = "CREATE TABLE `mythfilter` (
						  `id` int(10) unsigned NOT NULL auto_increment,
						  `search` varchar(255) NOT NULL default '',
						  `replace` varchar(255) NOT NULL default '',
						  `regex` int(2) unsigned NOT NULL default '0',
						  PRIMARY KEY  (`id`)
						) TYPE=MyISAM";
				mysql_query($query)
					or die("Error installing upgrading tables: ".mysql_error());
				$query = "ALTER TABLE `mythnode` ADD `rating` VARCHAR( 5 ) NOT NULL ,
						  ADD `numratings` INT UNSIGNED DEFAULT '0' NOT NULL ;";
				mysql_query($query)
					or die("Error installing upgrading tables: ".mysql_error());
				return true;
			}
		}
		function GetTrees()
		{
			$query = "SELECT * FROM `myth`";
			$result = mysql_query($query)
				or die(mysql_error());
			if(mysql_num_rows($result) > 0)
			{
				while($tree = mysql_fetch_array($result))
					$trees[] = $tree;
				if(!empty($trees))
					return $trees;
				return false;
			}
			return false;
		}
		function GetTreeRoot($tree)
		{
			$tree = (int)$tree;
			$query = "SELECT * FROM `mythnode` WHERE tree='$tree' AND parent='0'";
			$result = mysql_query($query)
				or die("Error getting tree root: " . mysql_error());
			$node = mysql_fetch_array($result);
			if(mysql_num_rows($result) < 1)
				return false;
			if(!empty($node))
				return $node;
			return false;
		}
		function GetNumNodes($tree)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$query = "SELECT COUNT(*) FROM `mythnode` WHERE tree='$tree'";
			$result = mysql_query($query)
				or die("Error: could not determine the number of nodes in tree");
			if(!$result)
				return false;
			$num = mysql_fetch_row($result);
			return $num[0];
		}
		function GetTree($tree)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$query = "SELECT * FROM `myth` WHERE id='$tree'";
			$result = mysql_query($query)
				or die("Error: could not retrieve tree");
			if(mysql_num_rows($result) < 1)
				return false;
			$tree = mysql_fetch_array($result);
			if(!isset($tree))
				return false;
			return $tree;
		}
		function GetTreeTitle($tree)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$query = "SELECT title FROM `myth` WHERE id='$tree'";
			$result = mysql_query($query)
				or die("Error: could not retrieve tree");
			if(mysql_num_rows($result) < 1)
				return false;
			$tree = mysql_fetch_array($result);
			if(!isset($tree))
				return false;
			return $tree['title'];		
		}
		function AddTree($title, $description = '')
		{
			$title = mysql_escape_string($title);
			$description = mysql_escape_string($description);
			if(empty($title))
				return false;
			if(strlen($title) > 127)
				return false;
			$query = "INSERT INTO `myth` (title,description) values('$title','$description')";
			$result = mysql_query($query)
				or die("Error adding new Myth: " . mysql_error());
			return true;			
		}
		function DelTree($tree)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$node = iMyth::GetTreeRoot($tree);
			iMyth::DelNode($node['id']);
			$query = "DELETE FROM `myth` WHERE id='$tree'";
			mysql_query($query)
				or die("Error: Could not delete tree.");
			return true;
		}
		function EditTree($tree, $title, $description)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$title = mysql_escape_string($title);
			$description = mysql_escape_string($description);
			if(empty($title))
				return false;
			$query = "UPDATE `myth` SET title='$title', description='$description' WHERE id='$tree'";
			mysql_query($query)
				or die("Error: could not edit tree");
			return true;
		}
		function NodeExists($id)
		{
			$id = (int)$id;
			$query = "SELECT id FROM `mythnode` WHERE id='$id'";
			$result = mysql_query($query)
				or die("Error determining whether node is existant: " .mysql_error());
			if(mysql_num_rows($result) > 0)
				return true;
			else
				return false;
		}
		function AddNode($tree, $parent, $content, $option1text, $option2text, $author = MYTH_ANON, $option = 0)
		{
			$tree = (int)$tree;
			if(!$tree)
				return false;
			$parent = (int)$parent;
			if($parent && $option != 1 && $option != 2)
				return false;
			if($parent)
			{
				$parentnode = iMyth::GetNode($parent);
				if($option == 1)
				{
					if($parentnode['option1node'] && iMyth::NodeExists($parentnode['option1node']))
						die("Error: A child of this node already exists.");
				}
				elseif($option == 2)
				{
					if($parentnode['option2node'] && iMyth::NodeExists($parentnode['option2node']))
						die("Error: A child of this node already exists.");
				}
			}
			$content = mysql_escape_string($content);
			$option1text = mysql_escape_string($option1text);
			$option2text = mysql_escape_string($option2text);
			$author = mysql_escape_string($author);
			if(!MYTH_NOCOOKIES && $author != MYTH_ANON)
				setcookie('name', $author, time()+3600*24*365);
			if(empty($content) || empty($option1text) || empty($option2text))
				return false;
			$authorip = mysql_escape_string($_SERVER['REMOTE_ADDR']);
			$query = "INSERT INTO `mythnode` (tree,parent,author,authorip,content,option1text,option2text) values('$tree', '$parent', '$author', '$authorip', '$content', '$option1text', '$option2text')";
			$result = mysql_query($query)
				or die("Error adding node: ".mysql_error());
			if($parent)
			{
				$query = "SELECT LAST_INSERT_ID()";
				$result = mysql_query($query)
					or die("Error getting last insert id: ".mysql_error());
				$id = mysql_fetch_row($result);
				$id = $id[0];
				$query = "UPDATE `mythnode` SET `when`=`when`, option" . $option . "node='$id' WHERE id='$parent'";
				$result = mysql_query($query)
					or die("Error updating parent: " . mysql_error());
				return $id;
			}
			return true;
		}
		function EditNode($id, $content, $option1text, $option2text, $author)
		{
			$id = (int)$id;
			if(!$id || !iMyth::NodeExists($id))
				die("Error: that node does not exist to edit.");
			$content = mysql_escape_string($content);
			$option1text = mysql_escape_string($option1text);
			$option2text = mysql_escape_string($option2text);
			$author = mysql_escape_string($author);
			if(empty($content) || empty($option1text) || empty($option2text))
				return false;
			$query = "UPDATE `mythnode` SET `when`=`when`,content='$content',option1text='$option1text',option2text='$option2text',author='$author' WHERE id='$id'";
			mysql_query($query)
				or die("Error editing node: ".mysql_error());
			return true;
		}
		function GetNode($id)
		{
			$id = (int)$id;
			if(!$id)
				return false;
			$query = "SELECT * FROM `mythnode` WHERE id='$id'";
			$result = mysql_query($query)
				or die("Error getting node: " . mysql_error());
			$node = mysql_fetch_array($result);
			if(!empty($node))
				return $node;
			return false;
		}
		function GetNodesLimit($limit = 20, $offset = 0, $tree = false)
		{
			$limit = (int)$limit;
			$offset = (int)$offset;
			$sub = '';
			if($tree !== false)
			{
				$tree = (int)$tree;
				$sub = "WHERE tree='$tree'";
			}
			$query = "SELECT * FROM `mythnode` $sub ORDER BY `when` DESC LIMIT $limit, $offset";
			$result = mysql_query($query)
				or die("Error getting node list: " . mysql_error());
			if(mysql_num_rows($result) > 0)
			{
				while($node = mysql_fetch_array($result))
					$nodes[] = $node;
				if(empty($nodes))
					return false;
				return $nodes;
			}
			return false;
		}
		function GetNumDeadEnds($tree = false)
		{
			$sub = '';
			if($tree !== false)
			{
				$tree = (int)$tree;
				$sub = "AND tree='$tree'";
			}
			$query = "SELECT COUNT(*) FROM `mythnode` WHERE option1node='0' AND option2node='0' $sub";
			$result = mysql_query($query)
				or die("Error retriving deadnodes: " . mysql_error());
			$num = mysql_fetch_row($result);
			return $num[0];
		}
		function GetChildren($parent)
		{
			$parent = (int)$parent;
			$query = "SELECT * FROM `mythnode` WHERE parent='$parent'";
			$result = mysql_query($query);
			if(!$result)
				return false;
			if(mysql_num_rows($result) < 1)
				return false;
			while($node = mysql_fetch_array($result))
				$nodes[] = $node;
			if(!empty($nodes))
				return $nodes;
			return false;
		}
		function DelNode($id)
		{
			$id = (int)$id;
			if(!$id)
				return false;
			while($children = iMyth::GetChildren($id))
			{
				foreach($children as $child)
					iMyth::DelNode($child['id']);
			}
			$query = "DELETE FROM `mythnode` WHERE id='$id'";
			$result = mysql_query($query);
			if(!$result)
				return false;
			return true;
		}
		function SetRating($id, $rating = 0)
		{
			$id = (int)$id;
			if(!$id)
				return false;
			if(!iMyth::NodeExists($id))
				return false;
			$rating = (int)$rating;
			$query = "SELECT numratings FROM `mythnode` WHERE id='$id'";
			$result = mysql_query($query);
			$num = mysql_fetch_row($result);
			$num = $num[0];
			if($num == 0)
				$query = "UPDATE `mythnode` SET `when`=`when`,rating='$rating',numratings=numratings+1 WHERE id='$id'";			
			else
				$query = "UPDATE `mythnode` SET `when`=`when`,rating=((rating+'$rating')/2),numratings=numratings+1 WHERE id='$id'";
			mysql_query($query)
				or die("Error setting rating: ".mysql_error());
			return true;
		}
		function Login($username, $password, $remember = 0)
		{
			if($remember != 2) //for cookie testing
			{
				if(MYTH_MD5PASS)
					$password = md5($password);
			}
			if($username == ADMIN_USER && $password == ADMIN_PASS)
			{
				$_SESSION['myth_username'] = $username;
				$_SESSION['myth_password'] = $password;
				if($remember)
				{
					setcookie('myth_username', $username, time()+3600*24*365);
					setcookie('myth_password', $password, time()+3600*24*365);
				}
				return true;
			}
			return false;
		}
		function Logout()
		{
			setcookie('myth_username', '', time()-3600*24*365);
			setcookie('myth_password', '', time()-3600*24*365);
			$_SESSION = array();
			session_destroy();
		}
		function IsAdmin()
		{
			if(!isset($_SESSION['myth_username']) || !isset($_SESSION['myth_password']))
				return false;
			if($_SESSION['myth_username'] == ADMIN_USER && $_SESSION['myth_password'] == ADMIN_PASS)
				return true;
			else
				return false;
		}
		function Optimize()
		{
			$query = "OPTIMIZE TABLE `mythnode`";
			mysql_query($query)
				or die("Error optimizing tables");
			$query = "OPTIMIZE TABLE `myth`";
			mysql_query($query)
				or die("Error optimizing tables");
			$query = "OPTIMIZE TABLE `mythfilter`";
			mysql_query($query)
				or die("Error optimizing tables");
			return true;
		}
		function Filter($text)
		{
			if($filters = iMyth::FilterGet()) {
			foreach($filters as $filter)
			{
				switch($filter['regex'])
				{
					default:
					case 0:
						$text = str_replace(stripslashes($filter['search']), stripslashes($filter['replace']), $text);
					break;
					case 1:
						$text = ereg_replace(stripslashes($filter['search']), stripslashes($filter['replace']), $text);
					break;
					case 2:
						$text = preg_replace(stripslashes($filter['search']), stripslashes($filter['replace']), $text);
					break;
				}
			} }
			return $text;
		}
		function FilterGet($id = false, $regex = false)
		{
			if($id === false)
			{
				$query = "SELECT * FROM `mythfilter`";
				if($regex !== false)
					$query .= " WHERE regex=1";
				$result = mysql_query($query)
					or die("Error retrieving filter data");
				if(mysql_num_rows($result) < 1)
					return false;
				while($filter = mysql_fetch_array($result))
					$filters[] = $filter;
				if(empty($filters))
					return false;
				return $filters;
			}
			else
			{
				$id = (int)$id;
				if(!$id)
					return false;
				$query = "SELECT * FROM `mythfilter` WHERE id='$id'";
				$result = mysql_query($query);
				if(mysql_num_rows($result) < 1)
					return false;
				$filter = mysql_fetch_array($result);
				if(empty($filter))
					return false;
				return $filter;
			}
		}
		function FilterAdd($search, $replace, $regex)
		{
			$search = mysql_escape_string($search);
			$replace = mysql_escape_string($replace);
			$regex = (int)$regex;
			if(empty($search))
				return false;
			$query = "INSERT INTO `mythfilter` (`search`,`replace`,`regex`) values('$search','$replace','$regex')";
			mysql_query($query)
				or die("Error adding filter");
			return true;
		}
		function FilterDel($id)
		{
			$id = (int)$id;
			if(!$id)
				return false;
			$query = "DELETE FROM `mythfilter` WHERE id='$id'";
			mysql_query($query)
				or die("Error deleting filter");
			return true;
		}
		function FilterEdit($id, $search, $replace, $regex)
		{
			$id = (int)$id;
			if(!$id)
				return false;
			$search = mysql_escape_string($search);
			$replace = mysql_escape_string($replace);
			$regex = (int)$regex;
			if(empty($search))
				return false;
			$query = "UPDATE `mythfilter` SET `search`='$search',`replace`='$replace',`regex`='$regex' WHERE id='$id'";
			mysql_query($query)
				or die("Error editing filter");
			return true;
		}
		function AddReferer()
		{
			if(!empty($_SERVER['HTTP_REFERER'])) {
				$referer = ereg_replace("\?(.*)$", "", mysql_escape_string($_SERVER['HTTP_REFERER']));
				if(ereg("^https?://([a-zA-Z0-9\.-]+)", $referer, $regs))
				{
					$referer = $regs[1];
					$referer = str_replace("www.", "", $referer);
					if(stristr($referer,$_SERVER['HTTP_HOST']))
						return;
					$query = "SELECT hits FROM `mythreferers` WHERE referer='$referer'";
					$result = mysql_query($query);
					if(!$result)
						die("bork bork bork!! zeta");
					if(mysql_num_rows($result) > 0)
					{
						$query = "UPDATE `mythreferers` SET hits=hits+1 WHERE referer='$referer'";
						mysql_query($query);
					}
					else
					{
						$query = "INSERT INTO `mythreferers` (referer) values('$referer')";
						mysql_query($query);
					} 
				}
			}
		}
		function AddStat()
		{
			$ip = mysql_escape_string($_SERVER['REMOTE_ADDR']);
				$query = "SELECT hits FROM `mythstats` WHERE ip='$ip'";
			$result = mysql_query($query);
			if(!$result)
				die("bork bork bork!! zeta");
			if(mysql_num_rows($result) > 0)
				$query = "UPDATE `mythstats` SET hits=hits+1 WHERE ip='$ip'";
			else
				$query = "INSERT INTO `mythstats` (ip) values('$ip')";
			$result = mysql_query($query);
			if(!$result)
				die("borkborkbork!! zeta");
		}
		function GetStats()
		{
			if(!iMyth::IsAdmin())
			die("j00 are teh naughty.");
			$query = "SELECT * FROM `mythreferers`";
			$result = mysql_query($query);
			if(!$result)
				die("borkborkbork!! epsilon");
			while($referer = mysql_fetch_array($result))
			{
				$referers[] = $referer;
			}
			$query = "SELECT *, DATE_FORMAT(`when`, '%d/%m/%y %H:%i') as nicetime FROM `mythstats`";
			$result = mysql_query($query);
			if(!$result)
				die("borkborkbork!!! epsilon");
			while($stat = mysql_fetch_array($result))
			{
				$stats[] = $stat;
			}
			return array('stats' => $stats, 'referers' => $referers);
		}
	}
	if(USE_GZIP)
		ob_start('ob_gzhandler');
	session_start();
	iMyth::Init();
	if(!iMyth::IsAdmin() && isset($_COOKIE['myth_username']) && isset($_COOKIE['myth_password']))
		iMyth::Login($_COOKIE['myth_username'], $_COOKIE['myth_password'], 2);
	if($_SERVER['REQUEST_METHOD'] == "POST")
	{
		if(isset($_POST['addtree']))
		{
			if(!iMyth::IsAdmin())
				die("You do not have permission to do this");
			if(empty($_POST['title']))
				die("Error: title field was empty");
			$title = $_POST['title'];
			$description = '';
			if(isset($_POST['description']))
				$description = $_POST['description'];
			if(iMyth::AddTree($title, $description))
			{
				header("Location: {$_SERVER['PHP_SELF']}");
				exit;
			}
			else
				die("There was an error adding a new myth");
		}
		elseif(isset($_POST['addnode']))
		{
			if(!empty($_POST['name']))
				$name = $_POST['name'];
			else
				$name = MYTH_ANON;
			if(empty($_POST['content']) || empty($_POST['option1text']) || empty($_POST['option2text']))
				die("Error: please fill out all the fields.");
			$content = $_POST['content'];
			$option1text = $_POST['option1text'];
			$option2text = $_POST['option2text'];
			$parent = (int)$_POST['parent'];
			$option = (int)$_POST['option'];
			$tree = (int)$_POST['tree'];
			if($parent && $option)
			{
				$parent = iMyth::GetNode($parent);
				if($id = iMyth::AddNode($parent['tree'], $parent['id'], $content, $option1text, $option2text, $name, $option))
				{
					header("Location: {$_SERVER['PHP_SELF']}?node=$id");
					exit;
				}
				else
				{
					die("Error: could not add node");
				}
				
			}
			elseif($tree)
			{
				if($id = iMyth::AddNode($tree, 0, $content, $option1text, $option2text, $name))
				{
					header("Location: {$_SERVER['PHP_SELF']}?tree=$tree");
					exit;
				}
				else
				{
					die("Error: could not create parentless node.");
				}
			}
			header("Location: {$_SERVER['PHP_SELF']}");
			exit;		
		}
		elseif(isset($_POST['editnode']))
		{
			if(!iMyth::IsAdmin())
				die("you do not have permission to access this.");
			if(!isset($_POST['id']))
				die("Error: no id was given during post");
			$id = (int)$_POST['id'];
			if(!iMyth::NodeExists($id))
				die("Error: the node you are trying to edit does not exist.");
			if(empty($_POST['content']) || empty($_POST['option1text']) || empty($_POST['option2text']))
			{
				die("Error: not all the required fields were completed");
			}		
			if(!iMyth::EditNode($id, $_POST['content'], $_POST['option1text'], $_POST['option2text'], $_POST['author']))
				die("Error: there was an unknown error editing the node");
			header("Location: {$_SERVER['PHP_SELF']}?node=$id");
			exit;
		}
		elseif(isset($_POST['edittree']))
		{
			if(!iMyth::IsAdmin())
				die("you do not have permission to access this.");
			 if(!isset($_POST['id']))
			 	die("Error: no id was given during post");
			$id = (int)$_POST['id'];
			if(empty($_POST['title']))
				die("Error: a title must be given");
			if(!iMyth::EditTree($id, $_POST['title'], $_POST['description']))
				die("Error: there was an unknown error editing the tree");
			header("Location: {$_SERVER['PHP_SELF']}");
			exit;
		}
		elseif(isset($_POST['login']))
		{
			if(isset($_POST['username']) && isset($_POST['password']))
			{
				$remember = 0;
				if(isset($_POST['remember']))
					$remember = 1;
				if(iMyth::Login($_POST['username'], $_POST['password'], $remember))
				{
					header("Location: {$_SERVER['PHP_SELF']}");
					exit;
				}
				else
					die("Invalid login info.");
			}
			else
				die("you did not enter a username and/or password");		
		}
		elseif(isset($_POST['addfilter']))
		{
			if(!iMyth::IsAdmin())
				die("you do not have permission to access this");
			if(isset($_POST['search']))
			{
				$search = $_POST['search'];
				$replace = '';
				if(isset($_POST['replace']))
					$replace = $_POST['replace'];
				$regex = 0;
				if(isset($_POST['regex']))
					$regex = $_POST['regex'];
				if(!iMyth::FilterAdd($search, $replace, $regex))
					die("there was a fatal error adding the filter");
				header("Location: {$_SERVER['PHP_SELF']}?w=filter");
				exit;
			}
			else
				die("you did not enter a search query");		
		}
		elseif(isset($_POST['editfilter']))
		{
			if(!iMyth::IsAdmin())
				die("you do not have permission to access this");
				
			$id = $_POST['id'];
			if(!$id)
				die("Fatal error, no id given to edit");
			if(isset($_POST['search']))
			{
				$search = $_POST['search'];
				$replace = '';
				if(isset($_POST['replace']))
					$replace = $_POST['replace'];
				$regex = 0;
				if(isset($_POST['regex']))
					$regex = $_POST['regex'];
				if(!iMyth::FilterEdit($id, $search, $replace, $regex))
					die("there was a fatal error adding the filter");
				header("Location: {$_SERVER['PHP_SELF']}?w=filter");
				exit;
			}
			else
				die("you did not enter a search query");		
		}
	}
	if(isset($_GET['node']) && isset($_GET['option']))
	{
		$option = $_GET['option'];
		$node = iMyth::GetNode($_GET['node']);
		if($option == 1)
		{
			$node = iMyth::GetNode($node['option1node']);
			if($node)
			{
				header("Location: {$_SERVER['PHP_SELF']}?node={$node['id']}");
				exit;
			}
		}
		elseif($option == 2)
		{
			$node = iMyth::GetNode($node['option2node']);
			if($node)
			{
				header("Location: {$_SERVER['PHP_SELF']}?node={$node['id']}");
				exit;
			}
		}
		unset($node);
	}
	if(isset($_GET['w']) && $_GET['w'] == 'logout')
	{
		iMyth::Logout();
		header("Location: {$_SERVER['PHP_SELF']}");
		exit;
	}
	if(isset($_GET['w']) && $_GET['w'] == 'rate')
	{
		if(MYTH_ALLOWRATING) {
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			$rating = 0;
			if(isset($_GET['rating']))
				$rating = $_GET['rating'];
			iMyth::SetRating($wid, $rating);
		}
			header("Location: {$_SERVER['PHP_SELF']}?node=$wid");
			exit;
	}
	if(MYTH_USESTATS && $_GET['w'] != 'login' && $_GET['w'] != 'install' && $_GET['w'] != 'upgrade')
	{
		//require("mythstats.php");
		if($_GET['w'] != 'stats')
			iMyth::AddStat();
		if(isset($_SERVER['HTTP_REFERER']))
			iMyth::AddReferer();
	}	
if(!MYTH_EMBEDDED) {
?>
<?php echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">"; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?= MYTH_TITLE ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<link href="<?= MYTH_CSS ?>" rel="stylesheet" type="text/css" />
<? /* if u wanna change the stylesheet please change the config at the top of this file */ ?>
</head>
<body>
<? }
	$node = array();
	if(isset($_GET['node']))
	{
		$nodeid = $_GET['node'];
		if(isset($_GET['option']))
		{
			$option = $_GET['option'];
			if($option != 1 && $option != 2)
				die("Error: invalid option");
			$node = iMyth::GetNode($nodeid);
			if($option == 1)
				$node = iMyth::GetNode($node['option1node']);
			elseif($option == 2)
				$node = iMyth::GetNode($node['option2node']);
		}
		else
			$node = iMyth::GetNode($nodeid);
	}
	elseif(isset($_GET['tree']))
	{
		$node = iMyth::GetTreeRoot($_GET['tree']);
	}
	if(isset($_GET['node']) || isset($_GET['tree'])) {
	if(!empty($node))
	{
	$node['content'] = nl2br(stripslashes(strip_tags($node['content'])));
	if(MYTH_USEFILTER)
		$node['content'] = iMyth::Filter($node['content']);
	?>
	<table width="99%" border="0" class="background" cellpadding="1" cellspacing="1">
	<tr class="header"><td>Author: <? if(!empty($node['author'])) echo stripslashes(strip_tags($node['author'])); else echo 'Unknown'; ?><? if(iMyth::IsAdmin() && MYTH_SHOWIP && $node['authorip']) echo " | ({$node['authorip']})"; ?></td></tr>
	<tr class="body"><td><?= $node['content'] ?></td></tr>
	<tr class="body"><td>Do you:<br /><a accesskey="1" href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['id'] ?>&amp;option=1"><?= stripslashes(strip_tags($node['option1text'])) ?></a><br />
	<a accesskey="2" href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['id'] ?>&amp;option=2"><?= stripslashes(strip_tags($node['option2text'])) ?></a>
	</td></tr>
	</table>
<? if(MYTH_ALLOWRATING) { ?>
<form action="<?= $_SERVER['PHP_SELF'] ?>?w=rate&amp;wid=<?= $node['id'] ?>" method="get">
<input type="hidden" name="w" value="rate" />
<input type="hidden" name="wid" value="<?= $node['id'] ?>" /><? } ?>
	<? if($node['parent']) { ?><a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['parent'] ?>">[up]</a><? } ?><a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>">[top]</a><? if(MYTH_ALLOWLIST) { ?><a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=nodelist&amp;wid=<?= $node['id'] ?>">[list]</a><? } if(MYTH_ALLOWRATING) { ?> | Rating: <? if($node['numratings']) echo round($node['rating'], 1); else echo 'Not rated'; ?> Rate: <select class="txt" name="rating"><? for($i = 1; $i < 10; $i ++) { ?><option value="<?= $i ?>"><?= $i ?></option><? } ?></select><input type="submit" name="rate" class="btn" value="Rate" /></form><? } ?>
	<?
	if(iMyth::IsAdmin())
	{ ?>
	<hr />
	Admin: <a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=delnode&amp;wid=<?= $node['id'] ?>">[Del]</a> <a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=editnode&amp;wid=<?= $node['id'] ?>">[Edit]</a>
	<? }
	}
	else
	{
	?>
	This part of the story does not exist yet.<br />
	Please add your contribution to the story below:<hr />
	<form action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
	<table>
	<tr><td>Your Name</td><td><input type="text" class="txt" name="name" value="<? if(!MYTH_NOCOOKIES && isset($_COOKIE['name'])) echo $_COOKIE['name']; else echo MYTH_ANON; ?>" /></td></tr>
	<tr><td>Story</td><td><textarea name="content" class="txtbox" cols="60" rows="20"></textarea></td></tr>
	<tr><td>Option A</td><td><input type="text" class="txt" name="option1text" /></td></tr>
	<tr><td>Option B</td><td><input type="text" class="txt" name="option2text" /></td></tr>
	<tr><td colspan="2"><input type="submit" class="btn" name="addnode" value="Add" /></td></tr>
	</table>
	<input type="hidden" name="parent" value="<?= $nodeid ?>" />
	<input type="hidden" name="option" value="<?= $option ?>" />
	<? if(isset($_GET['tree'])) { ?><input type="hidden" name="tree" value="<?= $_GET['tree'] ?>" /><? } ?>
	</form>
	<?
		if($nodeid)
		{
			if($parentnode = iMyth::GetNode($nodeid))
			{
			?>
			<hr />
				Previous node:<br />
				<?= nl2br(stripslashes(strip_tags($parentnode['content']))) ?>
				<p class="prevnode">
				<? if($option == 1) $optiontext = $parentnode['option1text'];
				else $optiontext = $parentnode['option2text']; ?>
				You chose: <?= $optiontext ?>
				</p>
			<?			
			}
		}
	?>
	<?	
	} } else {
	$w = '';
	if(isset($_GET['w']))
		$w = $_GET['w'];
	switch($w)
	{
		case "addtree":
		if(!iMyth::IsAdmin())
			die("You do not have permission to access this");
			?>
			Enter a title and optionally a description for this myth. <hr />
			<form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
			<table>
			<tr><td>Title:</td><td><input type="text" class="txt" name="title" /></td></tr>
			<tr><td valign="top">Description:</td><td><textarea name="description" class="txtbox" cols="60" rows="20"></textarea></td></tr>
			</table>
			<br /><input type="submit" class="btn" name="addtree" value="Add Myth" style="width: 80px;" />
			</form>
			
			<?		
		break;
		case "delnode":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			if(isset($_GET['confirm']) && $_GET['confirm'] == 1)
			{
				iMyth::DelNode($wid);
				echo 'Node has been deleted.<br />';
				?><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a><?
			}
			else {
			?>
			Please confirm that you wish to delete this node and all nodes below it.<br />
			<a href="<?= $_SERVER['PHP_SELF'] ?>?w=delnode&amp;wid=<?= $wid ?>&amp;confirm=1" style="text-decoration: none;">Delete</a><br />
			<a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $wid ?>" style="text-decoration: none;">Cancel</a>
			<? }
		break;
		case "editnode":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			if(isset($node))
				unset($node);
			if($node = iMyth::GetNode($wid))
			{
			?>
			<h2>Edit node.</h2>
			<hr />
			<form action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
			<table>
			<tr><td>Author</td><td><input type="text" class="txt" name="author" value="<?= stripslashes($node['author']) ?>" /></td></tr>
			<tr><td>Story</td><td><textarea name="content" class="txtbox" cols="60" rows="20"><?= stripslashes($node['content']) ?></textarea></td></tr>
			<tr><td>Option A</td><td><input type="text" class="txt" name="option1text" value="<?= stripslashes($node['option1text']) ?>" /> <? if($node['option1node']) { ?><a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['option1node'] ?>">Goto</a><? } ?></td></tr>
			<tr><td>Option B</td><td><input type="text" class="txt" name="option2text" value="<?= stripslashes($node['option2text']) ?>" /> <? if($node['option2node']) { ?><a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['option1node'] ?>">Goto</a><? } ?></td></tr>
			<tr><td colspan="2"><input type="submit" class="btn" name="editnode" value="Edit" /></td></tr>
			</table>
			<input type="hidden" name="id" value="<?= $node['id'] ?>" />
			</form>
			<?
			}
			else
			{
				echo 'Error: could not retrieve node to edit.';
			}
		break;
		case "nodelist":
			if(!MYTH_ALLOWLIST)
			{
				echo 'Node list is not enabled.';
				break;
			}
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			if(!iMyth::NodeExists($wid))
				die("Node does not exist.");
			$mode = MYTH_LISTMODE;
			if(isset($_GET['mode']))
				$mode = $_GET['mode'];
			$node = iMyth::GetNode($wid);
			$treetitle = iMyth::GetTreeTitle($node['tree']);
			$nodelist = array();
			$nodelist[] = $node;
			while($node = iMyth::GetNode($node['parent']))
			{
				$nodelist[] = $node;
			}
			$nodelist = array_reverse($nodelist);
			?><h2><?= stripslashes($treetitle) ?></h2><?
			foreach($nodelist as $key => $node)
			{ 
				unset($choice);
				if($nodelist[$key+1]['id'] == $node['option1node'])
					$choice = $node['option1text'];
				elseif($nodelist[$key+1]['id'] == $node['option2node'])
					$choice = $node['option2text'];
				else
					$choice = '';
				if($mode == 2)
					$choice = '';
			?>
				<table width="99%" border="0" class="background" cellpadding="1" cellspacing="1">
				<? if($mode == 3) { ?><tr class="header"><td>Author: <? if(!empty($node['author'])) echo stripslashes(strip_tags($node['author'])); else echo 'Unknown'; ?></td></tr> <? } ?>
				<tr class="body"><td><?= nl2br(stripslashes(strip_tags($node['content']))) ?></td></tr>
				<? if(!empty($choice)) { ?><tr class="body"><td>You: <?= stripslashes(strip_tags($choice)) ?></td></tr><? } ?>
				</table><br />
			<?
			}
			echo 'The End';
		break;
		case "deltree":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			if(isset($_GET['confirm']) && $_GET['confirm'] == 1)
			{
				iMyth::DelTree($wid);
				echo 'Tree has been deleted.<br />';
				?><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a><?
			}
			else {
			?>
			Please confirm that you wish to delete this tree and all nodes below it.<br />
			<a href="<?= $_SERVER['PHP_SELF'] ?>?w=deltree&amp;wid=<?= $wid ?>&amp;confirm=1" style="text-decoration: none;">Delete</a><br />
			<a href="<?= $_SERVER['PHP_SELF'] ?>" style="text-decoration: none;">Cancel</a>
			<? }		
		break;
		case "edittree":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!isset($_GET['wid']))
				die("No wid set.");
			$wid = (int)$_GET['wid'];
			if(!$wid)
				die("No wid set.");
			if($tree = iMyth::GetTree($wid)) {
			?>
			Enter a title and optionally a description for this myth. <hr />
			<form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
			<table>
			<tr><td>Title:</td><td><input type="text" class="txt" name="title" value="<?= $tree['title'] ?>" /></td></tr>
			<tr><td valign="top">Description:</td><td><textarea name="description" class="txtbox" cols="60" rows="20"><?= stripslashes($tree['description']) ?></textarea></td></tr>
			</table>
			<br /><input type="submit" class="btn" name="edittree" value="Edit" style="width: 80px;" />
			<input type="hidden" name="id" value="<?= $tree['id'] ?>" />
			</form>
			<? }
			else
				echo 'Error: could not retrieve tree to edit.';
		break;
		case "latest":
			$tree = false;
			if(isset($_GET['wid']))
				$tree = $_GET['wid'];
			$offset = 0;
			$limit = MYTH_DEFLIMIT;
			if(isset($_GET['offset']))
				$offset = $_GET['offset'];
			if(isset($_GET['limit']))
				$limit = $_GET['limit'];
			if($nodes = iMyth::GetNodesLimit($offset, $limit, $tree))
			{
				if($tree === false) {
				?>
				<h2>Latest nodes in all trees</h2>
				<?
				}
				else
				{
				?>
				<h2>Latest nodes in <?= iMyth::GetTreeTitle($tree) ?></h2>
				<?
				}
				foreach($nodes as $node)
				{ ?>
				<a name="<?= $node['id'] ?>" />
				<table width="99%" border="0" class="background" cellpadding="1" cellspacing="1">
			<? if($tree === false) { ?>	<tr class="header"><td>Tree: <?= iMyth::GetTreeTitle($node['tree']) ?></td></tr><? } ?>
				<tr class="header"><td>id: <a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['id'] ?>"><?= $node['id'] ?></a> Parent: <a href="#<?= $node['parent'] ?>"><?= $node['parent'] ?></a> Author: <? if(!empty($node['author'])) echo stripslashes(strip_tags($node['author'])); else echo 'Unknown'; ?><? if(iMyth::IsAdmin() && MYTH_SHOWIP && $node['authorip']) echo " | ({$node['authorip']})"; ?></td></tr>
				<tr class="body"><td><?= nl2br(stripslashes(strip_tags($node['content']))) ?></td></tr>
				<tr class="body"><td>Do you:<br /><a href="#<?= $node['option1node'] ?>">[<?= $node['option1node'] ?>]</a> <a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['id'] ?>&amp;option=1"><?= stripslashes(strip_tags($node['option1text'])) ?></a><br />
				<a href="#<?= $node['option2node'] ?>">[<?= $node['option2node'] ?>]</a> <a href="<?= $_SERVER['PHP_SELF'] ?>?node=<?= $node['id'] ?>&amp;option=2"><?= stripslashes(strip_tags($node['option2text'])) ?></a>
				</td></tr>
				</table><br />
			<?	}
			?><a href="<?= $_SERVER['PHP_SELF'] ?>?w=latest&amp;offset=<?= $offset + $limit ?>&amp;limit=<?= $limit ?><? if($tree !== false) echo "&amp;wid=$tree"; ?>">Prev <?= $limit ?></a><? if($offset >= $limit) { ?> <a href="<?= $_SERVER['PHP_SELF'] ?>?w=latest&amp;offset=<?= $offset - $limit ?>&amp;limit=<?= $limit ?><? if($tree !== false) echo "&amp;wid=$tree"; ?>">Next <?= $limit ?></a><? }
			}
			else
				echo 'No nodes';
		break;
		case "login":
			?>
			<form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
			Username: <input type="text" class="txt" name="username" /><br />
			Password: <input type="password" class="txt" name="password" /><br />
			Autologin: <input type="checkbox" name="remember" /><br />
			<input type="submit" value="Login" name="login" class="btn" />
			</form>			
			<?		
		break;
		case "logout":
			iMyth::Logout();
			echo 'You have been logged out.';
			?><br /><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a><?
		break;
		case "filter":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!MYTH_USEFILTER)
			{
				echo 'Filter is not enabled.';
				break;
			}
			if(isset($_GET['wid']))
			{
				if($_GET['wid'] == 'add')
				{
				?>
					Enter the search and replace term, select regex mode (<a href="http://uk.php.net/manual/en/function.ereg-replace.php">ereg</a> or <a href="http://uk.php.net/manual/en/function.preg-replace.php">preg</a>) if you wish to use them.<br />
					<form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
					<table>
					<tr><td>Search:</td><td><input type="text" class="txt" name="search" /></td></tr>
					<tr><td>Replace:</td><td><input type="text" class="txt" name="replace" /></td></tr>
					<tr><td>Regex:</td><td><select name="regex" class="txt"><option value="0">Off</option><option value="1">ereg</option><option value="2">preg</option></select></td></tr>
					<tr><td colspan="2"><input type="submit" class="btn" name="addfilter" value="Add" /></td></tr>
					</table>
					</form>
					<hr /><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a>
				<?
				}
				elseif(is_numeric($_GET['wid'])) //edit mode
				{
					$id = $_GET['wid'];
					$filter = iMyth::FilterGet($id);
				?>
					Enter the search and replace term, tick the box if you wish to use <a href="http://uk.php.net/manual/en/function.ereg-replace.php">regex</a> capability.<br />
					<form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
					<table>
					<tr><td>Search:</td><td><input type="text" class="txt" name="search" value="<?= stripslashes($filter['search']) ?>" /></td></tr>
					<tr><td>Replace:</td><td><input type="text" class="txt" name="replace" value="<?= /* " */ str_replace('"', '&quot;', stripslashes($filter['replace'])) ?>" /></td></tr>
					<tr><td>Regex:</td><td><select name="regex" class="txt"><option value="0" <? if($filter['regex'] == 0) echo 'selected="selected"'; ?>>Off</option><option value="1" <? if($filter['regex'] == 1) echo 'selected="selected"'; ?>>ereg</option><option value="2" <? if($filter['regex'] == 2) echo 'selected="selected"'; ?>>preg</option></select></td></tr>
					<input type="hidden" name="id" value="<?= $id ?>" />
					<tr><td colspan="2"><input type="submit" class="btn" name="editfilter" value="Edit" /></td></tr>
					</table>
					</form>
					<hr /><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a>
				<?
				}
			}
			elseif(isset($_GET['wdel']))
			{
				$id = $_GET['wdel'];
				if(!iMyth::FilterDel($id))
					die("Error deleting filter");
				echo "Filter Deleted<br /><a href=\"{$_SERVER['PHP_SELF']}?w=filter\">Back</a>";
			}
			else
			{
				if($filters = iMyth::FilterGet())
				{
					?><table border="0" class="background" cellpadding="1" cellspacing="1"><tr class="header"><td>id</td><td>Search</td><td>Replace</td><td>Regex</td><td>Del/Edit</td></tr><?
					foreach($filters as $filter)
					{
					?><tr class="body"><td><?= $filter['id'] ?></td><td><?= htmlspecialchars(stripslashes($filter['search'])) ?></td><td><?= htmlspecialchars(stripslashes($filter['replace'])) ?></td><td><? if($filter['regex'] == 1) echo 'ereg'; elseif($filter['regex'] == 2) echo 'preg'; else echo 'Off'; ?></td><td><a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=filter&amp;wid=<?= $filter['id'] ?>">[edit]</a><a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=filter&amp;wdel=<?= $filter['id'] ?>">[del]</a></td></tr><?
					}
					?></table><?
				}
				else
					echo 'There are no filters<br />';
				?><a href="<?= $_SERVER['PHP_SELF'] ?>?w=filter&amp;wid=add">Add</a><hr /><a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a><?
			}
		break;
		case "stats":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this");
			if(!MYTH_USESTATS)
			{
				echo 'Stats are not enabled.';
				break;
			}	
			$fnord = iMyth::GetStats();
			$stats = $fnord['stats'];
			$referers = $fnord['referers'];
			?>
			Stats: <a href="<?= $_SERVER['PHP_SELF'] ?>?w=stats&amp;resolve=1">[resolve]</a><br>
			<table border="1" cellpadding="1" cellspacing="1">
			<tr><td>ID</td><td>IP</td><td>Hits</td><td>Last Time</td></tr>
			<?
				$totalhits = 0;
				foreach($stats as $stat)
				{
					if($_GET['resolve'] == 1)
						$stat['ip'] = gethostbyaddr($stat['ip']);
					$totalhits += $stat['hits'];
					?><tr><td><?= $stat['id'] ?></td><td><?= $stat['ip'] ?></td><td><?= $stat['hits'] ?></td><td><?= $stat['nicetime'] ?></td></tr><?
				}
			?>
			</table><br>
			Referers:<br>
			<table border="1" cellpadding="1" cellspacing="1">
			<tr><td>ID</td><td>Url</td><td>Hits</td></tr>
			<?
				$refhits = 0;
				if($referers) {
				foreach($referers as $referer)
				{
					$refhits += $referer['hits'];
					?><tr><td><?= $referer['id'] ?></td><td><?= $referer['referer'] ?></td><td><?= $referer['hits'] ?></td></tr><?
				}
				}
			?>
			</table>
			<?= $totalhits ?> - <?= $refhits ?> = <?= $totalhits - $refhits ?><br>
			<? 
		break;
		case "optimize":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this.");
			iMyth::Optimize();
			?>
			Your database has been optimized successfully<br />
			<a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a>
			<?
		break;
		case "install":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this.");
			if($_GET['confirm'] == 1)
			{
				iMyth::Install();
				?>
				Database has been installed.<br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a>
				<?
			}	
			else
			{
				?>
				Install new database? If you have already installed this will throw errors.<br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>?w=install&amp;confirm=1">Confirm</a><br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>">Cancel</a>
				<?
			}
		break;
		case "upgrade":
			if(!iMyth::IsAdmin())
				die("You do not have permission to access this.");
			if($_GET['confirm'] == 1)
			{
				iMyth::Upgrade('2.0');
				?>
				Database has been upgraded.<br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>">Home</a>
				<?
			}
			else
			{
				?>
				Upgrade database? If you have already upgraded this will throw errors.<br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>?w=upgrade&amp;confirm=1">Confirm</a><br />
				<a href="<?= $_SERVER['PHP_SELF'] ?>">Cancel</a>
				<?			
			}
		break;
		default:
			$trees = iMyth::GetTrees();
			if(!empty($trees))
			{
			?><h1 class="titletext">Myth2</h1>
			Myth2 is an interactive story of sorts, you read the story and make one of two choices on what to do next,<br />
			this continues until you come to a dead end and there is no things next, at which point you have the option<br />
			to add to the story.<br /><br />
			Myths:<hr /><?
				foreach($trees as $tree)
				{
					?><div class="header"><a href="<?= $_SERVER['PHP_SELF'] ?>?tree=<?= $tree['id'] ?>"><?= stripslashes(strip_tags($tree['title'])) ?></a><? if(MYTH_SHOWCOUNT) { ?> (<?= iMyth::GetNumNodes($tree['id']) ?>) (<?= iMyth::GetNumDeadEnds($tree['id']) ?> dead ends)<? } ?></div><? if($tree['description']) { ?><div class="body"><?= nl2br(stripslashes(strip_tags($tree['description']))) ?></div><? } ?>
					<? if(iMyth::IsAdmin()) { ?>
					<a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=latest&amp;wid=<?= $tree['id'] ?>&amp;limit=<?= MYTH_DEFLIMIT ?>&amp;offset=0">[latest]</a> <a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=deltree&amp;wid=<?= $tree['id'] ?>">[del]</a> <a style="text-decoration: none;" href="<?= $_SERVER['PHP_SELF'] ?>?w=edittree&amp;wid=<?= $tree['id'] ?>">[edit]</a><br /><? } ?>
					<br /><?
				}
			}
			if(iMyth::IsAdmin()) { ?><hr />Admin<br /><a href="<?= $_SERVER['PHP_SELF'] ?>?w=addtree">New Myth</a><br /><a href="<?= $_SERVER['PHP_SELF'] ?>?w=latest&amp;limit=<?= MYTH_DEFLIMIT ?>&amp;offset=0">Latest Nodes</a><br /><? if(MYTH_USEFILTER) { ?><a href="<?= $_SERVER['PHP_SELF'] ?>?w=filter">Filter</a><br /><? } ?><? if(MYTH_USESTATS) { ?><a href="<?= $_SERVER['PHP_SELF'] ?>?w=stats">Stats</a><br /><? } ?><a href="<?= $_SERVER['PHP_SELF'] ?>?w=optimize">Optimize Tables</a><br /><a href="<?= $_SERVER['PHP_SELF'] ?>?w=logout">Logout</a><? } else { if(MYTH_SHOWLOGIN) { ?><hr /><a href="<?= $_SERVER['PHP_SELF'] ?>?w=login">Login</a><? }}
			?><hr /><div align="right" style="font-size: x-small;">Powered by <a target="_blank" style="text-decoration: none;" href="http://solidox.org/myth2/">Myth2 v<?= MYTH_VERSION ?></a></div><?
		break;
	} }
	$time_end = getmicrotime();
	$time = $time_end - $time_start;
	echo "\n<!-- Page generated in: $time secs -->\n";
if(!MYTH_EMBEDDED) {
?>
</body>
</html>
<? } 
	if(USE_GZIP)
		ob_end_flush();
/* EOF */
?>