<?

function retIMDBsearch($title)
{
    $query = urlencode(trim($title));

    $handle = fopen("http://imdb.com/find?q=" . $query . ";s=all", "r");
    $out = '';

    while (!feof($handle))
    {
        $out .= fread($handle, 8192);
    }

    fclose($handle);

	preg_match("{/title/tt\d{7}/}", $out, $result);
 
    $handle = fopen("http://us.imdb.com" . $result[0], "r");
    $out = '';

    while (!feof($handle))
    {
    $out .= fread($handle, 8192);
    }

    $link='http://us.imdb.com' . $result[0];

    fclose($handle);

    $input=$out;

    $outData='';

    //title
   	$pos = strpos($out,"<title>") + 7;
    $raw = substr($out,$pos,strpos($out,"</title>") - $pos);
    $res = substr($raw,0,strpos($raw," ("));
    $outData = $res . ' - ';
    $title = $res;

    if (preg_match_all("/<title>.*\s*\((\d{4})\)<\/title>/i",$out, $result))
    {
        $outData .= $result[1][0];
    }
    else
    {
        $outData .= 'Year unknown';
    }

    $outData .= "<br>";
    
    //director
    $pos = strpos($out,"Directed by</b><br>") + 47;
    $posend = strpos($out,"</a><br>",$pos);
    $res = substr($out,$pos,$posend-$pos);
    $outData .= "Directed by: " . $res . "<br>";

    //tagline
    if (preg_match("/Tagline:<\/b>\s(.*)/i", $out, $result))
    {
        $res = strip_tags($result[1]);
        $res = str_replace('(more)', '', $res);
        $res = trim($res);
        $outData .= "Tagline: ";
        $outData .= $res . "<br>";
    }

    //starrating
    if (preg_match_all("/<B>([0-9]\.[0-9])\/10<\/B>/i",$input, $result))
    {
        $rate = $result[1][0];
        $outData .= "Rating: " . $rate . "/10<br>";
    }

    //plot
    if (preg_match("/Plot Outline:<\/b>(.*)(\<+)*\./i", $input, $result))
    {
        $outData .= 'Plot: ' . strip_tags($result[1]) . ".<br>";
    }
    
    //runtime
    if (preg_match("/Runtime:<\/b>((?:.|\s)*?)<br>/i", $input, $result))
    {
        $outData .= 'Runtime: ' . strip_tags(trim($result[1])) . "<br>";
    }
    
    //mpaarating
    if (preg_match("{certificates=USA:((?:.|\s)*?)&}", $input, $result))
    {
        $outData .= 'MPAA Rating: ' . strip_tags($result[1]) ."<br>";
    }

    $outData .= '<a href="' . $link . '">IMDB Link</a>';

    return $outData;

}
