<?php

function retThesaurus($word)
{
    $url="http://thesaurus.reference.com/search?q=" . $word;
    $fd = fopen($url,"r");
    $pgdata = "";
    $thesaurus = "";
    while(!feof($fd))
	{
		$pgdata .= fread($fd, 5000);   
		$start = strpos($pgdata, "<tr><td align=\"right\" valign=\"top\"><b>Synonyms:</b>&nbsp;&nbsp;</td><td>");
		$end = strpos($pgdata, "<tr><td align=right valign=top><a href=\"/help/about.html\" title");
		$size = $end - $start;
		$thesaurus = strip_tags(substr($pgdata, $start, $size));
	}

    $thesaurus = str_replace("Synonyms:&nbsp;&nbsp;","<b>Synonyms:</b> ",$thesaurus);
    $thesaurus = str_replace("Antonyms:&nbsp;&nbsp;","<br><b>Antonyms:</b> ",$thesaurus);

    if($thesaurus == "")
        return FALSE;
        
    return $thesaurus;
}

function retDictionary($word)
{
    $url="http://dictionary.reference.com/search?q=" . $word;
    $fd = fopen($url,"r");
    $pgdata = "";
    $dictionary = "";
    while(!feof($fd))
	{
		$pgdata .= fread($fd, 10000);
        $start = strpos($pgdata, "<b>Pronunciation Key</b>");
        $start = 6 + strpos($pgdata, ")<BR>", $start);
        //$start = 450 + strpos($pgdata,"<!-- google_ad_region_start=def -->");
        $end = strpos($pgdata, "</OL><BR>");
		$size = $end - $start;
  		//$dictionary = strip_tags(substr($pgdata, $start, $size));
  		$dictionary = substr($pgdata, $start, $size);
	}
 
    //echo "<br>start: $start<br>end: $end<br>size: $size<br>";
    
    //header
    $dictionary = "<b>$word</b><br>" . $dictionary;
    //strip images
    $dictionary = eregi_replace("<IMG[^>]*>", "", $dictionary);
    //turn ordered lists into <br>'s
    $dictionary = eregi_replace("<OL[^>]*>", "", $dictionary);
    $dictionary = eregi_replace("<LI[^>]*>", "<br>- ", $dictionary);
    $dictionary = eregi_replace("</LI[^>]*>", "", $dictionary);
    $dictionary = eregi_replace("</OL[^>]*>", "", $dictionary);
    //turn cites into italics
    $dictionary = eregi_replace("<CITE[^>]*>", "<i>", $dictionary);
    $dictionary = eregi_replace("</CITE[^>]*>", "</i>", $dictionary);

    $dictionary = html_entity_decode($dictionary,ENT_QUOTES);
    //$dictionary = preg_replace('~&#([0-9]+);~e', 'chr(\\1)', $dictionary);
    
    //cause htmt_entity_decode doesn't do shit
    $dictionary = str_replace("&#145;","'",$dictionary);
    $dictionary = str_replace("&#146;","'",$dictionary);
    $dictionary = str_replace("&#147;","\"",$dictionary);
    $dictionary = str_replace("&#148;","\"",$dictionary);
    $dictionary = str_replace("&#183;","",$dictionary);

    if($dictionary == "")
        return FALSE;
        
    return $dictionary;
}

?>
